/***************************************************************************

    Copyright 2008 Frederik Gladhorn <frederik.gladhorn@kdemail.net>

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LESSONSTATISTICSVIEW_H
#define LESSONSTATISTICSVIEW_H

#include "containerview.h"

/**
 * View for the lesson list.
 * @author Frederik Gladhorn <frederik.gladhorn@kdemail.net>
 */
class LessonStatisticsView : public ContainerView
{
    Q_OBJECT

public:
    LessonStatisticsView(QWidget *parent);
    void setModel(ContainerModel *model);

private Q_SLOTS:
    void removeGrades();
    void removeGradesChildren();

protected:
    virtual void resizeEvent(QResizeEvent *event);

private Q_SLOTS:
    void sectionResized(int index, int /*oldSize*/, int /*newSize*/);
    void adjustColumnWidths();

private:
    virtual void setModel(QAbstractItemModel *model) {
        Q_UNUSED(model)
    }
};

#endif
